unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TextToTStrings(const List : TStrings; const FileName : String);
begin
  with List do begin
    Clear;
    LoadFromFile(FileName);
  end;
end;

procedure TStringsToText(const List : TStrings; const FileName : String);
begin
  with List do
    SaveToFile(FileName);
end;

procedure IterTextToTStrings(Wnd : THandle; const List : TStrings;
                             const FileName : String);
var
  txt : TextFile;
  buf : String;
begin
  AssignFile(txt, FileName);
  Reset(txt);
  List.Clear;
  LockWindowUpdate(Wnd);
  while NOT EOF(txt) do begin
    ReadLn(txt, buf);
    List.Add(buf);
  end;
  LockWindowUpdate(0);
  CloseFile(txt);
end;

procedure IterTStringsToText(const List : TStrings; const FileName : String);
var
  txt : TextFile;
  I   : Integer;
begin
  if FileExists(FileName) then
    if (MessageDlg('File ' + FileName + ' exists. Overwrite?', mtConfirmation,
        [mbOk, mbCancel], 0) = mrCancel) then
        Exit;

  AssignFile(txt, FileName);
  Rewrite(txt);
  for I := 0 to (List.Count - 1) do begin
    WriteLn(txt, List[0]);
  end;
  CloseFile(txt);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  with OpenDialog1 do
    if Execute then
      Edit1.Text := FileName;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  TextToTStrings(Memo1.Lines, Edit1.Text);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  TStringsToText(Memo1.Lines, Edit1.Text);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  IterTextToTStrings(Self.Handle, Memo1.Lines, Edit1.Text);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  IterTStringsToText(Memo1.Lines, Edit1.Text);
end;

end.
